/**
 * 20241029 ©WANGKANG 1686617586@qq.com
 */

package com.taais.biz.service;

import java.util.List;

import com.taais.biz.domain.TargetDetection;
import com.taais.biz.domain.TaskTrackResultBo;
import com.taais.biz.domain.vo.TargetDetectionVo;
import com.taais.biz.domain.bo.TargetDetectionBo;
import com.taais.common.core.core.domain.CommonResult;
import com.taais.common.orm.core.service.IBaseService;
import com.taais.common.core.core.page.PageResult;
import org.springframework.core.io.Resource;
import org.springframework.http.ResponseEntity;

/**
 * 目标检测Service接口
 *
 * @author wangkang
 * 2024-09-29
 */
public interface ITargetDetectionService extends IBaseService<TargetDetection> {
    /**
     * 查询目标检测
     *
     * @param id 目标检测主键
     * @return 目标检测
     */
        TargetDetectionVo selectById(Long id);

    /**
     * 查询目标检测列表
     *
     * @param targetDetectionBo 目标检测Bo
     * @return 目标检测集合
     */
    List<TargetDetectionVo> selectList(TargetDetectionBo targetDetectionBo);

    /**
     * 分页查询目标检测列表
     *
     * @param targetDetectionBo 目标检测Bo
     * @return 分页目标检测集合
     */
    PageResult<TargetDetectionVo> selectPage(TargetDetectionBo targetDetectionBo);

    /**
     * 新增目标检测
     *
     * @param targetDetectionBo 目标检测Bo
     * @return 结果:true 操作成功，false 操作失败
     */
    boolean insert(TargetDetectionBo targetDetectionBo);

    /**
     * 修改目标检测
     *
     * @param targetDetectionBo 目标检测Bo
     * @return 结果:true 更新成功，false 更新失败
     */
    boolean update(TargetDetectionBo targetDetectionBo);

    /**
     * 批量删除目标检测
     *
     * @param ids 需要删除的目标检测主键集合
     * @return 结果:true 删除成功，false 删除失败
     */
    boolean deleteByIds(Long[] ids);

    CommonResult start(Long id);

    CommonResult stop(Long id);

    CommonResult getResult(TaskTrackResultBo taskTrackResultBo);

    ResponseEntity<Resource> zipImages(Long id);

    CommonResult getLog(Long id);

    CommonResult getModelList(Long id);
}
